# Create a new task

POST https://api.letsdeel.com/rest/v2/contracts/{contract_id}/tasks
Content-Type: application/json

Create a new task for a contractor associated with a specific Deel contract. A task can include details like amount, description, submission date.
 **Token scopes**: `contracts:write`

Reference: https://developer.deel.com/api/endpoints/tasks/create-contract-task

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /contracts/{contract_id}/tasks:
    post:
      operationId: create-contract-task
      summary: Create a new task
      description: >-
        Create a new task for a contractor associated with a specific Deel
        contract. A task can include details like amount, description,
        submission date.
         **Token scopes**: `contracts:write`
      tags:
        - subpackage_tasks
      parameters:
        - name: contract_id
          in: path
          description: The unique Deel contract ID associated with the task.
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: The task was successfully created.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/tasks_createContractTask_Response_201'
        '400':
          description: Bad request. Missing required fields or invalid data format.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateANewTaskRequestBadRequestError'
        '401':
          description: Unauthorized. Authentication credentials are missing or invalid.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateANewTaskRequestUnauthorizedError'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: >-
            Internal server error. An unexpected error occurred while processing
            the request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateANewTaskRequestInternalServerError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/ContractsContractIdTasksPostRequestBodyContentApplicationJsonSchemaData
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    ContractsContractIdTasksPostRequestBodyContentApplicationJsonSchemaDataDateSubmitted:
      oneOf:
        - type: string
          format: date
        - type: string
          format: date-time
      description: >-
        The date the task was submitted, in ISO 8601 format. Also accepts
        date-time (YYYY-MM-DDTHH:MM:SSZ).
      title: >-
        ContractsContractIdTasksPostRequestBodyContentApplicationJsonSchemaDataDateSubmitted
    ContractsContractIdTasksPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        amount:
          type: string
          description: >-
            The amount to be associated with the task, in the appropriate
            currency.
        description:
          type:
            - string
            - 'null'
          description: A description of the task.
        date_submitted:
          $ref: >-
            #/components/schemas/ContractsContractIdTasksPostRequestBodyContentApplicationJsonSchemaDataDateSubmitted
          description: >-
            The date the task was submitted, in ISO 8601 format. Also accepts
            date-time (YYYY-MM-DDTHH:MM:SSZ).
        is_auto_approved:
          type: boolean
          description: >-
            If true, the task will be automatically approved as part of the
            request.
      required:
        - amount
        - description
        - date_submitted
      title: ContractsContractIdTasksPostRequestBodyContentApplicationJsonSchemaData
    ContractsContractIdTasksPostResponsesContentApplicationJsonSchemaDataStatus:
      type: string
      enum:
        - approved
        - declined
        - not_payable
        - paid
        - pending
        - processing
      description: The current status of the task.
      title: >-
        ContractsContractIdTasksPostResponsesContentApplicationJsonSchemaDataStatus
    ContractsContractIdTasksPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier for the created task.
        status:
          oneOf:
            - $ref: >-
                #/components/schemas/ContractsContractIdTasksPostResponsesContentApplicationJsonSchemaDataStatus
            - type: 'null'
          description: The current status of the task.
        created:
          type: boolean
          description: Indicates whether the task creation operation was successful.
      title: ContractsContractIdTasksPostResponsesContentApplicationJsonSchemaData
    tasks_createContractTask_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/ContractsContractIdTasksPostResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: tasks_createContractTask_Response_201
    CreateANewTaskRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
      title: CreateANewTaskRequestBadRequestError
    CreateANewTaskRequestUnauthorizedError:
      type: object
      properties:
        error:
          type: string
      title: CreateANewTaskRequestUnauthorizedError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
    CreateANewTaskRequestInternalServerError:
      type: object
      properties:
        error:
          type: string
      title: CreateANewTaskRequestInternalServerError
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks"

payload = { "data": {
        "amount": "1500.00",
        "description": "Completion of Q1 project tasks",
        "date_submitted": "2024-11-01"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"amount":"1500.00","description":"Completion of Q1 project tasks","date_submitted":"2024-11-01"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks"

	payload := strings.NewReader("{\n  \"data\": {\n    \"amount\": \"1500.00\",\n    \"description\": \"Completion of Q1 project tasks\",\n    \"date_submitted\": \"2024-11-01\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"amount\": \"1500.00\",\n    \"description\": \"Completion of Q1 project tasks\",\n    \"date_submitted\": \"2024-11-01\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"amount\": \"1500.00\",\n    \"description\": \"Completion of Q1 project tasks\",\n    \"date_submitted\": \"2024-11-01\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks', [
  'body' => '{
  "data": {
    "amount": "1500.00",
    "description": "Completion of Q1 project tasks",
    "date_submitted": "2024-11-01"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"amount\": \"1500.00\",\n    \"description\": \"Completion of Q1 project tasks\",\n    \"date_submitted\": \"2024-11-01\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "amount": "1500.00",
    "description": "Completion of Q1 project tasks",
    "date_submitted": "2024-11-01"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/contracts/37nex2x/tasks")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```